Subject: Re: [PATCH net-next 1/9] net: Remove martian_source_keep_err goto label

From: Alexander Duyck <[email-masked]>
Date: Tue, 22 Sep 2015 18:39:16 -0700

On 09/22/2015 06:04 PM, Alexander Duyck wrote:
> On 09/22/2015 03:55 PM, David Ahern wrote:
>> err is initialized to -EINVAL when it is declared. It is not reset until
>> fib_lookup which is well after the 3 users of the martian_source jump. So
>> resetting err to -EINVAL at martian_source label is not needed.
>>
>> Removing that line obviates the need for the martian_source_keep_err
>> label
>> so delete it.
>>
>> Signed-off-by: David Ahern <[email-masked]>
>
> The comments above and the code below don't sync up.  The function
> fib_validate_source can return either -EINVAL, -EXDEV, 0, or 1.  The
> fact is this may be acceptable as long as all callers of
> ip_route_input_slow will handle a non-zero value as an error and it
> doesn't care about what the actual return value is.  If that is what you
> are going for here at least the comment should be updated, and we should
> be explicit somewhere about documenting the return values.

Actually this patch is correct.  I got my wires a bit crossed and 
misread martian_source vs martian_source_keep_err.